#include "Play.hpp"
#include "SDL.h"
#include <AL/al.h>
#include <AL/alut.h>
#include <Graphics/Graphics.hpp>
#include <Graphics/Texture.hpp>
#include <vector>
#include <stdlib.h> 
#include <stdio.h> 
#include <Graphics/Font.hpp>

#include <iostream>
#include <sstream>
#include <string>

ALuint yay, no, block, pow1, left, right, loss, wina, ouch, source;	
int i, neg1, neg2;
float startx;
float starty;
string healthprint, tmp;
string youprint;
std::stringstream out;
bool display_pow;
bool played_end;
bool sounds;

Play::Play() {
  played_end = false;
  sounds = true;
  win = false;
  lose = false;
  display_pow = false;
  healthprint = "Boss Health: ";
  youprint = "Your Health: ";
  srand(time(0));
  for (i=0; i<4; i++){
    evils[i].pos.x = 0.0f;
    evils[i].pos.y = 0.0f;
    evils[i].tar.x = 0.0f;
    evils[i].tar.y = 0.0f;
  }

  boss.health = 100;
  you.health = 100;
  boss.pos = 3;
  you.pos = 0;
  timer = 0.0f;

  ra_pos.x = Graphics::aspectf() - 0.5f;
  ra_pos.y = -0.75f;
  la_pos.x = -Graphics::aspectf() + 0.5f;
  la_pos.y = -0.75f;

  ra_tar.x = Graphics::aspectf() - 0.5f;
  ra_tar.y = -0.75f;
  la_tar.x = -Graphics::aspectf() + 0.5f;
  la_tar.y = -0.75f;

  
  yay = alutCreateBufferFromFile("../yay.wav");
  if (yay == AL_NONE){
    printf("failed.\n");
  }  

  no = alutCreateBufferFromFile("../nonono.wav");
  if (no == AL_NONE){
    printf("failed.\n");
  }  

  block = alutCreateBufferFromFile("../block.wav");
  if (block == AL_NONE){
    printf("failed.\n");
  }  

  pow1 = alutCreateBufferFromFile("../pow.wav");
  if (pow1 == AL_NONE){
    printf("failed.\n");
  }  
  
  left = alutCreateBufferFromFile("../punchleft.wav");
  if (left == AL_NONE){
    printf("failed.\n");
  } 
  
  right = alutCreateBufferFromFile("../punchright.wav");
  if (right == AL_NONE){
    printf("failed.\n");
  }
  
  loss = alutCreateBufferFromFile("../fail.wav");
  if (loss == AL_NONE){
    printf("failed.\n");
  }
  
  ouch = alutCreateBufferFromFile("../ouch.wav");
  if (ouch == AL_NONE){
    printf("failed.\n");
  }
  
  wina = alutCreateBufferFromFile("../win.wav");
  if (wina == AL_NONE){
    printf("failed.\n");
  }
}

Play::~Play() {
}

void play_lose(){
    if (sounds){

  alGenSources(1, &source);
  alSourcei(source, AL_BUFFER, loss);
  alSourcePlay(source);
  int error = alGetError(); 
  if (error) printf("%s\n", alutGetErrorString(error));
  }
}

void play_win(){
    if (sounds){

  alGenSources(1, &source);
  alSourcei(source, AL_BUFFER, wina);
  alSourcePlay(source);
  int error = alGetError(); 
  if (error) printf("%s\n", alutGetErrorString(error));
  }
}

void play_ouch(){
  if (sounds){
  alGenSources(1, &source);
  alSourcei(source, AL_BUFFER, ouch);
  alSourcePlay(source);
  int error = alGetError(); 
  if (error) printf("%s\n", alutGetErrorString(error));
  }
}

void play_yay(){
    if (sounds){
  alGenSources(1, &source);
  alSourcei(source, AL_BUFFER, yay);
  alSourcePlay(source);
  int error = alGetError(); 
  if (error) printf("%s\n", alutGetErrorString(error));
    }
}

void play_no(){
    if (sounds){

  alGenSources(1, &source);
  alSourcei(source, AL_BUFFER, no);
  alSourcePlay(source);
  int error = alGetError(); 
  if (error) printf("%s\n", alutGetErrorString(error));
    }
}

void play_block(){
  if (sounds){

  alGenSources(1, &source);
  alSourcei(source, AL_BUFFER, block);
  alSourcePlay(source);
  int error = alGetError(); 
  if (error) printf("%s\n", alutGetErrorString(error));
  }
}

void play_pow(){
  if (sounds){

  alGenSources(1, &source);
  alSourcei(source, AL_BUFFER, pow1);
  alSourcePlay(source);
  int error = alGetError(); 
  if (error) printf("%s\n", alutGetErrorString(error));
  }
}

void play_left(){
  if (sounds){

  alGenSources(1, &source);
  alSourcei(source, AL_BUFFER, left);
  alSourcePlay(source);
  int error = alGetError(); 
  if (error) printf("%s\n", alutGetErrorString(error));
  }
}

void play_right(){
  if (sounds){

  alGenSources(1, &source);
  alSourcei(source, AL_BUFFER, right);
  alSourcePlay(source);
  int error = alGetError(); 
  if (error) printf("%s\n", alutGetErrorString(error));
  }
}

void Play::draw() {
  glClearColor(0.5f, 0.5f, 0.5f, 0.0f);
  glClear(GL_COLOR_BUFFER_BIT);
  //Draw things here.
  
  Graphics::TextureRef tex = Graphics::get_texture("../house.png");
  if (tex.ref) {
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, tex->obj);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  }
  glBegin(GL_QUADS);
  glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
  glTexCoord2f(1.0f, 1.0f);
  glVertex2f(Graphics::aspectf(), 1.0f);
  glTexCoord2f(1.0f, 0.0f);
  glVertex2f(Graphics::aspectf(), -1.0f);
  glTexCoord2f(0.0f, 0.0f);
  glVertex2f(-Graphics::aspectf(), -1.0f);
  glTexCoord2f(0.0f, 1.0f);
  glVertex2f(-Graphics::aspectf(), 1.0f);
  glEnd();
  
 

  tex = Graphics::get_texture("../ghost.png");
  if (tex.ref) {
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, tex->obj);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  }
  
  for (i=0; i<4; i++){
    glBegin(GL_QUADS);
    glTexCoord2f(1.0f, 1.0f);
    glVertex2f(evils[i].pos.x + 0.5f, evils[i].pos.y + 0.5f);
    glTexCoord2f(1.0f, 0.0f);
    glVertex2f(evils[i].pos.x + 0.5f, evils[i].pos.y - 0.5f);
    glTexCoord2f(0.0f, 0.0f);
    glVertex2f(evils[i].pos.x - 0.5f, evils[i].pos.y - 0.5f);
    glTexCoord2f(0.0f, 1.0f);
    glVertex2f(evils[i].pos.x - 0.5f, evils[i].pos.y + 0.5f);
    glEnd();
  }

  
  out.str(std::string());
  out << boss.health;
  tmp = out.str();
  healthprint = "Boss Health: ";
  healthprint += tmp;
  Graphics::FontRef font = Graphics::get_font("gentium.txf");
  assert(font.ref);
  glColor3f(0.5f, 1.0f, 0.5f);
  font->draw_center(healthprint, make_vector(0.9f, 0.85f), 0.1f);

  out.str(std::string());
  out << you.health;
  tmp = out.str();
  youprint = "Your Health: ";
  youprint += tmp;
  glColor3f(1.0f, 0.5f, 0.5f);
  font->draw_center(youprint, make_vector(-0.9f, 0.85f), 0.1f);
  
  glColor3f(1.0f, 1.0f, 1.0f);
  
  if (display_pow){
    tex = Graphics::get_texture("../pow.png");
    if (tex.ref) {
      glEnable(GL_TEXTURE_2D);
      glBindTexture(GL_TEXTURE_2D, tex->obj);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    }
    glBegin(GL_QUADS);
    glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
    glTexCoord2f(1.0f, 1.0f);
    glVertex2f(Graphics::aspectf(), 1.0f);
    glTexCoord2f(1.0f, 0.0f);
    glVertex2f(Graphics::aspectf(), -1.0f);
    glTexCoord2f(0.0f, 0.0f);
    glVertex2f(-Graphics::aspectf(), -1.0f);
    glTexCoord2f(0.0f, 1.0f);
    glVertex2f(-Graphics::aspectf(), 1.0f);
    glEnd();
  }

  tex = Graphics::get_texture("../leftarm.png");
  if (tex.ref) {
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, tex->obj);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  }
  
  for (i=0; i<4; i++){
    glBegin(GL_QUADS);
    glTexCoord2f(1.0f, 1.0f);
    glVertex2f(la_pos.x + 0.35f, la_pos.y + 0.7f);
    glTexCoord2f(1.0f, 0.0f);
    glVertex2f(la_pos.x + 0.35f, la_pos.y - 0.7f);
    glTexCoord2f(0.0f, 0.0f);
    glVertex2f(la_pos.x - 0.35f, la_pos.y - 0.7f);
    glTexCoord2f(0.0f, 1.0f);
    glVertex2f(la_pos.x - 0.35f, la_pos.y + 0.7f);
    glEnd();
  }

  tex = Graphics::get_texture("../rightarm.png");
  if (tex.ref) {
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, tex->obj);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  }
  
  for (i=0; i<4; i++){
    glBegin(GL_QUADS);
    glTexCoord2f(1.0f, 1.0f);
    glVertex2f(ra_pos.x + 0.35f, ra_pos.y + 0.7f);
    glTexCoord2f(1.0f, 0.0f);
    glVertex2f(ra_pos.x + 0.35f, ra_pos.y - 0.7f);
    glTexCoord2f(0.0f, 0.0f);
    glVertex2f(ra_pos.x - 0.35f, ra_pos.y - 0.7f);
    glTexCoord2f(0.0f, 1.0f);
    glVertex2f(ra_pos.x - 0.35f, ra_pos.y + 0.7f);
    glEnd();
  }

  if (win){
    tex = Graphics::get_texture("../win.png");
    if (tex.ref) {
      glEnable(GL_TEXTURE_2D);
      glBindTexture(GL_TEXTURE_2D, tex->obj);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    }
    glBegin(GL_QUADS);
    glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
    glTexCoord2f(1.0f, 1.0f);
    glVertex2f(Graphics::aspectf(), 1.0f);
    glTexCoord2f(1.0f, 0.0f);
    glVertex2f(Graphics::aspectf(), -1.0f);
    glTexCoord2f(0.0f, 0.0f);
    glVertex2f(-Graphics::aspectf(), -1.0f);
    glTexCoord2f(0.0f, 1.0f);
    glVertex2f(-Graphics::aspectf(), 1.0f);
    glEnd();
  }
  
  else if (lose){
    tex = Graphics::get_texture("../fail.png");
    if (tex.ref) {
      glEnable(GL_TEXTURE_2D);
      glBindTexture(GL_TEXTURE_2D, tex->obj);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    }
    glBegin(GL_QUADS);
    glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
    glTexCoord2f(1.0f, 1.0f);
    glVertex2f(Graphics::aspectf(), 1.0f);
    glTexCoord2f(1.0f, 0.0f);
    glVertex2f(Graphics::aspectf(), -1.0f);
    glTexCoord2f(0.0f, 0.0f);
    glVertex2f(-Graphics::aspectf(), -1.0f);
    glTexCoord2f(0.0f, 1.0f);
    glVertex2f(-Graphics::aspectf(), 1.0f);
    glEnd();
  }

}

void Play::update(float elapsed_time) {
  Vector2f to;
  timer += elapsed_time;
  for (i=0; i<4; i++){
    if (rand() % 2 == 0) neg1 = 1; else neg1 = -1;
    if (rand() % 2 == 0) neg2 = 1; else neg2 = -1;
    
    if ((evils[i].pos.x == evils[i].tar.x) && 
	(evils[i].pos.y == evils[i].tar.y)){
      evils[i].tar.x = ((rand()/float(RAND_MAX))*Graphics::aspectf())*neg1;
      evils[i].tar.y = (rand()/float(RAND_MAX))*neg2;
    }
    else {
      to = evils[i].tar - evils[i].pos;
      if (length(to) < elapsed_time * 0.5f) 
	evils[i].pos = evils[i].tar;
      else 
	evils[i].pos += normalize(to) * elapsed_time * 0.75f;
    }
  }
  
  to = ra_tar - ra_pos;
  if (length(to) < elapsed_time * 0.5f) 
    ra_pos = ra_tar;
  else 
    ra_pos += normalize(to) * elapsed_time * 0.75f;
  
  to = la_tar - la_pos;
  if (length(to) < elapsed_time * 0.5f) 
    la_pos = la_tar;
  else 
    la_pos += normalize(to) * elapsed_time * 0.75f;

  if (timer >= 0.4){
    display_pow = false;
  }

  if (timer >= 1.5f){
    if (boss.pos ==3){
      if ((rand()/float(RAND_MAX))> 0.25f){
	if ((rand()/float(RAND_MAX))> 0.5f){
	  boss.pos = 1;
	  play_right();
	}
	else{
	  boss.pos = 0;
	  play_left();
	}
      }
      else{
	boss.pos = 2;
	play_block();
      }
      
    }
  }
  
  if (timer >= 5.0f){
    timer = 0.0f;
    if (boss.pos == 2){
      if (you.pos != 2){
	you.health = you.health - 20;
	play_ouch();
      }
      else
	play_yay();
    }
    boss.pos = 3;
  }

  if (boss.health <= 0){
    win = true;
    if (!played_end){
      play_win();
      played_end = true;
    }
    sounds = false;
  }
  if (you.health <= 0) {
    lose = true;
    if (!played_end){
      play_lose();
      played_end = true;
    }
    sounds = false;
  }
    

}



void Play::handle_event(SDL_Event const &event) {
  //Handle events here:
  if (event.type == SDL_KEYDOWN) {
    if (win || lose){
      alutExit();
      quit_screen(this);
    }

    if (event.key.keysym.sym == SDLK_ESCAPE) {
      //escape quits.
      alutExit();
      quit_screen(this);
    }
    
    else if (event.key.keysym.sym == SDLK_a) {
      la_tar.y = -0.3f;
      you.pos = 1;
      if (boss.pos != 0){
	you.health = you.health - 20;
	timer = 0.0f;
	boss.pos = 3;
	play_no();
      }
      else{
	boss.health = boss.health - 20;
	timer = 0.0f;
	boss.pos = 3;
	display_pow = true;
	play_pow();
      }
    }
    
    else if (event.key.keysym.sym == SDLK_d) {
      ra_tar.y = -0.3f;
      you.pos = 3;
      if (boss.pos != 1){
	you.health = you.health - 20;
	timer = 0.0f;
	boss.pos =3;
	play_no();
      }
      else{
	boss.health = boss.health - 20;
	timer = 0.0f;
	boss.pos = 3;
	display_pow = true;
	play_pow();
      }
    }
    else if (event.key.keysym.sym == SDLK_s) {
      ra_tar.y = -0.65f;
      la_tar.y = -0.65f;
      ra_tar.x = 0.5f;
      la_tar.x = -0.5f;
      you.pos = 2;
    }
  }
  if (event.type == SDL_KEYUP) {
    ra_tar.x = Graphics::aspectf() - 0.5f;
    ra_tar.y = -0.75f;
    la_tar.x = -Graphics::aspectf() + 0.5f;
    la_tar.y = -0.75f;
    you.pos = 0;
    
  }
  
}
